<?php
/*
Simple:Press Plugin Title: File Uploader with Plupload
Version: 2.0.2
Plugin URI: http://simple-press.com
Description: A Simple:Press plugin for uploading images, media and files in posts
Author: Andy Staines & Steve Klasen
Author URI: http://simple-press.com
Simple:Press Versions: 5.2 and above
$LastChangedDate: 2013-02-23 12:00:07 -0700 (Sat, 23 Feb 2013) $
$Rev: 9882 $
*/

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

global $sfglobals;

# IMPORTANT DB VERSION
define('SPPLUPDBVERSION', 3);

define('SPPLUPDIR', 		SFPLUGINDIR.'plupload/');
define('SPPLUPADMINDIR', 	SFPLUGINDIR.'plupload/admin/');
define('SPPLUPLIBDIR', 		SFPLUGINDIR.'plupload/library/');
define('SPPLUPAHAHDIR', 	SFPLUGINDIR.'plupload/ahah/');
define('SPPLUPCSS', 		SFPLUGINURL.'plupload/resources/css/');
define('SPPLUPSCRIPT', 		SFPLUGINURL.'plupload/resources/jscript/');
define('SPPLUPI18NDIR',     SFPLUGINDIR.'plupload/resources/jscript/i18n/');
define('SPPLUPI18NURL',     SFPLUGINURL.'plupload/resources/jscript/i18n/');
define('SPPLUPIMAGES',		SFPLUGINURL.'plupload/resources/images/');
define('SPPLUPIMAGESMOB',	SFPLUGINURL.'plupload/resources/images/mobile/');

add_action('init', 												'sp_plupload_localization');
add_action('sph_activate_plupload/sp-plupload-plugin.php', 		'sp_plupload_install');
add_action('sph_deactivate_plupload/sp-plupload-plugin.php', 	'sp_plupload_deactivate');
add_action('sph_uninstall_plupload/sp-plupload-plugin.php', 	'sp_plupload_uninstall');
add_action('sph_activated', 				                    'sp_plupload_sp_activate');
add_action('sph_deactivated', 				                    'sp_plupload_sp_deactivate');
add_action('sph_uninstalled', 								    'sp_plupload_sp_uninstall');
add_action('sph_ahah_handler_plupload-manage', 				    'sp_plupload_ahah_manage');
add_action('sph_print_plugin_scripts', 							'sp_plupload_load_js');
add_action('sph_print_plugin_styles',							'sp_plupload_head');
add_action('sph_ahah_handler_plupload',							'sp_plupload_upload');
add_action('sph_ahah_handler_plupload-remove',					'sp_plupload_remove');
add_action('sph_admin_menu', 									'sp_plupload_menu');
add_action('sph_integration_storage_panel_location', 			'sp_plupload_storage_location');
add_action('sph_integration_storage_save', 						'sp_plupload_storage_save');
add_action('sph_post_create', 									'sp_plupload_post_create');
add_action('sph_post_edit_after_save', 							'sp_plupload_post_create');
add_action('sph_setup_forum', 								    'sp_plupload_process_actions');
add_action('sph_topic_delete', 									'sp_plupload_topic_delete');
add_action('sph_post_delete', 									'sp_plupload_post_delete');
add_action('admin_footer',                                      'sp_plupload_upgrade_check');
add_action('sph_plugin_update_plupload/sp-plupload-plugin.php', 'sp_plupload_upgrade_check');
add_action('sph_admin_panel_header',                            'sp_plupload_gd_check');
add_action('sph_permissions_reset',                             'sp_plupload_reset_permissions');

add_filter('sph_plugins_active_buttons', 	    'sp_plupload_uninstall_option', 10, 2);

if ($sfglobals['display']['editor']['toolbar']) {
	add_filter('sph_topic_editor_toolbar_buttons',	'sp_plupload_editor_button', 5, 4);
	add_filter('sph_post_editor_toolbar_buttons',	'sp_plupload_editor_button', 5, 4);
}

add_filter('sph_topic_editor_footer_top',	    'sp_plupload_uploader_form', 10, 3);
add_filter('sph_post_editor_footer_top',	    'sp_plupload_uploader_form', 10, 3);
add_filter('sph_post_edit_footer_top',	        'sp_plupload_uploader_edit_form', 10, 4);

add_filter('sph_SignaturesFormBottom',		    'sp_plupload_uploader_sig_form', 10, 2);
add_filter('sph_integration_tooltips', 		    'sp_plupload_tooltip');
add_filter('sph_forumview_combined_data', 	    'sp_plupload_forumview_query', 10, 2);
add_filter('sph_TopicIndexStatusIconsLast',     'sp_plupload_status_icon');
add_filter('sph_topicview_query', 			    'sp_plupload_topic_query');
add_filter('sph_topicview_post_records', 	    'sp_plupload_post_records', 10, 2);
add_filter('sph_PostIndexContent', 			    'sp_plupload_show_attachments');
add_filter('sph_add_post_tool', 	            'sp_plupload_post_tool', 10, 9);
add_filter('sph_acknowledgements',			    'sp_plupload_acknowledgement');
add_filter('sph_admin_help-admin-components',   'sp_plupload_admin_help', 10, 3);
add_filter('sph_perms_tooltips', 		 	    'sp_plupload_perm_tooltip', 10, 2);

# do we need the profile photo uploader?
$uploads = sp_get_option('spPlupload');
if ($uploads['useforphotos']) {
    add_filter('sph_ProfilePhotosFormTop',          'sp_plupload_uploader_photos_top', 10, 2);
    add_filter('sph_ProfilePhotosFormBottom',	    'sp_plupload_uploader_photos_form', 10, 2);
    add_filter('sph_profile_save_thisForm',         'sp_plupload_photos_this_form');
    add_filter('sph_ProfileFormSave_photos-upload', 'sp_plupload_photos_upload', 10, 3);
    add_filter('sph_ProfileShowUserPhotos_args',    'sp_plupload_photos_args');
    add_filter('sph_ProfileShowUserPhotos',         'sp_plupload_photos_show', 10, 3);
}

function sp_plupload_menu() {
    $subpanels = array(
                __('File Uploads', 'sp-plup') => array('admin' => 'sp_plupload_admin_options', 'save' => 'sp_plupload_admin_save_options', 'form' => 1, 'id' => 'plupopt')
                            );
    sp_add_admin_subpanel('components', $subpanels);
}

function sp_plupload_admin_options() {
    include_once(SPPLUPLIBDIR.'sp-plupload-components.php');
    include_once(SPPLUPADMINDIR.'sp-plupload-admin-options.php');
	sp_plupload_admin_options_form();
}

function sp_plupload_admin_save_options() {
    include_once(SPPLUPLIBDIR.'sp-plupload-components.php');
    include_once(SPPLUPADMINDIR.'sp-plupload-admin-options-save.php');
    return sp_plupload_admin_options_save();
}

function sp_plupload_localization() {
	sp_plugin_localisation('sp-plup');
}

function sp_plupload_admin_help($file, $tag, $lang) {
    if ($tag == '[image-files]' || $tag == '[media-files]' || $tag == '[other-files]' || $tag == '[upload-settings]' || $tag == '[prohibited-files]') $file = SPPLUPADMINDIR.'sp-plupload-admin-help.'.$lang;
    return $file;
}

function sp_plupload_install() {
    include_once(SPPLUPDIR.'sp-plupload-install.php');
    sp_plupload_do_install();
}

function sp_plupload_uninstall() {
    include_once(SPPLUPDIR.'sp-plupload-uninstall.php');
    sp_plupload_do_uninstall();
}

function sp_plupload_deactivate() {
    include_once(SPPLUPDIR.'sp-plupload-uninstall.php');
    sp_plupload_do_deactivate();
}

function sp_plupload_sp_activate() {
	include_once(SPPLUPDIR.'sp-plupload-install.php');
    sp_plupload_do_sp_activate();
}

function sp_plupload_sp_deactivate() {
	include_once(SPPLUPDIR.'sp-plupload-uninstall.php');
    sp_plupload_do_sp_deactivate();
}

function sp_plupload_sp_uninstall() {
	include_once(SPPLUPDIR.'sp-plupload-uninstall.php');
    sp_plupload_do_sp_uninstall();
}

function sp_plupload_uninstall_option($actionlink, $plugin) {
    include_once(SPPLUPDIR.'sp-plupload-uninstall.php');
    $actionlink = sp_plupload_uninstall_option_links($actionlink, $plugin);
	return $actionlink;
}

function sp_plupload_upgrade_check() {
    include_once(SPPLUPDIR.'sp-plupload-upgrade.php');
    sp_plupload_do_upgrade_check();
}

function sp_plupload_reset_permissions() {
    include_once(SPPLUPDIR.'sp-plupload-install.php');
    sp_plupload_do_reset_permissions();
}

function sp_plupload_tooltip($tooltips) {
    include_once(SPPLUPLIBDIR.'sp-plupload-components.php');
    $tooltips = sp_plupload_do_tooltip($tooltips);
	return $tooltips;
}

function sp_plupload_perm_tooltip($tooltips) {
    $tooltips['download_attachments'] = $t.__('Can download attachments for other file type uploads', 'sp-plup');
	return $tooltips;
}

function sp_plupload_head() {
    include_once(SPPLUPLIBDIR.'sp-plupload-components.php');
    sp_plupload_do_head();
}

function sp_plupload_load_js($footer) {
    include_once(SPPLUPLIBDIR.'sp-plupload-components.php');
    sp_plupload_do_load_js($footer);
}

function sp_plupload_forumview_query($forums, $topics) {
    include_once(SPPLUPLIBDIR.'sp-plupload-components.php');
    $forums = sp_plupload_do_forumview_query($forums, $topics);
	return $forums;
}

function sp_plupload_storage_location() {
    include_once(SPPLUPLIBDIR.'sp-plupload-components.php');
    sp_plupload_do_storage_location();
}

function sp_plupload_storage_save() {
    include_once(SPPLUPLIBDIR.'sp-plupload-components.php');
    sp_plupload_do_storage_save();
}

function sp_plupload_upload() {
	include_once(SPPLUPLIBDIR.'sp-plupload-upload.php');
}

function sp_plupload_remove() {
	include_once(SPPLUPLIBDIR.'sp-plupload-remove.php');
}

function sp_plupload_editor_button($out, $forum, $a, $toolbar) {
	global $SFDEVICE;
    if (sp_get_auth('upload_images', $forum->forum_id) || sp_get_auth('upload_media', $forum->forum_id) || sp_get_auth('upload_files', $forum->forum_id)) {

    	if (($SFDEVICE=='mobile') && (defined('SP_MOBILE_THEME') && SP_MOBILE_THEME)) {
			# display mobile icon
			return $out.= "<img src='".SPPLUPIMAGESMOB."sp_PlupAttachment.png' class='spIcon' id='spUploadsButton' onclick='spjOpenEditorBox(\"spUploadsBox\");' />";
		} else {
			return $out.= "<input type='button' class='spSubmit spLeft vtip' title='".__('Open/Close to Upload Attachments', 'sp-plup')."' id='spUploadsButton' value='".__('Attachments', 'sp-plup')."' onclick='spjOpenEditorBox(\"spUploadsBox\");' />";
		}
	}
}

function sp_plupload_uploader_form($out, $object, $a) {
    include_once(SPPLUPLIBDIR.'sp-plupload-components.php');
	include_once(SPPLUPLIBDIR.'sp-plupload-forms.php');
	$out = sp_plupload_do_uploader_form($out, $object);
	return $out;
}

function sp_plupload_uploader_edit_form($out, $object, $pid, $a) {
    include_once(SPPLUPLIBDIR.'sp-plupload-components.php');
	include_once(SPPLUPLIBDIR.'sp-plupload-forms.php');
	$out = sp_plupload_do_uploader_form($out, $object, '', $pid, 'edit');
	return $out;
}

function sp_plupload_uploader_sig_form($out, $uid) {
    include_once(SPPLUPLIBDIR.'sp-plupload-components.php');
	include_once(SPPLUPLIBDIR.'sp-plupload-forms.php');
	$out = sp_plupload_do_uploader_form($out, '', $uid, '', 'sig');
	return $out;
}

function sp_plupload_uploader_photos_top($out, $id) {
    global $formStart;
    $formStart = $out;
    return $out;
}

function sp_plupload_uploader_photos_form($out, $uid) {
    include_once(SPPLUPLIBDIR.'sp-plupload-components.php');
	include_once(SPPLUPLIBDIR.'sp-plupload-forms.php');
	$out = sp_plupload_do_uploader_profile_form($uid);
	return $out;
}

function sp_plupload_photos_this_form($thisForm) {
    if ($thisForm == 'edit-photos') $thisForm = 'photos-upload';
    return $thisForm;
}

function sp_plupload_photos_upload($message, $thisUser, $thisForm) {
    if ($thisForm = 'photos-upload') {
	   include_once(SPPLUPLIBDIR.'sp-plupload-components.php');
	   $message = sp_plupload_do_uploader_photos_save($message, $thisUser, $thisForm);
    }
	return $message;
}

function sp_plupload_post_create($newpost) {
    include_once(SPPLUPLIBDIR.'sp-plupload-components.php');
    sp_plupload_do_post_create($newpost);
}

function sp_plupload_status_icon($out) {
	include_once(SPPLUPLIBDIR.'sp-plupload-components.php');
	$out = sp_plupload_do_status_icon($out);
	return $out;
}

function sp_plupload_topic_query($spdb) {
	$spdb->fields.= ', attachments';
	return $spdb;
}

function sp_plupload_post_records($post, $records) {
	$post->attachments = unserialize($records->attachments);
	return $post;
}

function sp_plupload_show_attachments($out) {
	include_once(SPPLUPLIBDIR.'sp-plupload-components.php');
	$out = sp_plupload_do_show_attachments($out);
	return $out;
}

function sp_plupload_post_tool($out, $post, $forum, $topic, $page, $postnum, $useremail, $guestemail, $displayname) {
    include_once(SPPLUPLIBDIR.'sp-plupload-components.php');
	$out = sp_plupload_do_post_tool($out, $forum, $topic, $post);
    return $out;
}

function sp_plupload_ahah_manage() {
    include_once(SPPLUPLIBDIR.'sp-plupload-components.php');
    include_once(SPPLUPAHAHDIR.'sp-plupload-ahah-manage.php');
}

function sp_plupload_process_actions() {
    include_once(SPPLUPLIBDIR.'sp-plupload-components.php');
	sp_plupload_do_process_actions();
}

function sp_plupload_acknowledgement($ack) {
	$ack[] = __("Image uploader library by ", "sp-plup").': <a href="http://plupload.com/">Plupload</a>';
	return $ack;
}

function sp_plupload_topic_delete($posts) {
    include_once(SPPLUPLIBDIR.'sp-plupload-components.php');
	sp_plupload_do_topic_delete($posts);
}

function sp_plupload_post_delete($post) {
    include_once(SPPLUPLIBDIR.'sp-plupload-components.php');
	sp_plupload_do_post_delete($post);
}

function sp_plupload_photos_args($a) {
    $a['showEmpty'] = 1;
    return $a;
}

function sp_plupload_photos_show($out, $spProfileUser, $a) {
    include_once(SPPLUPLIBDIR.'sp-plupload-components.php');
	$out = sp_plupload_do_photos_show($out, $spProfileUser, $a);
    return $out;
}

function sp_plupload_gd_check() {
    include_once(SPPLUPLIBDIR.'sp-plupload-components.php');
	sp_plupload_do_gd_check();
}
?>